#ifndef INCLUDED_GAMELIB_HASHMAP_H
#define INCLUDED_GAMELIB_HASHMAP_H

#include "GameLib/Base/Stack.h"
#include "GameLib/Base/Hash.h"
#include "GameLib/Base/Array.h"

namespace GameLib{

///EeʎwnbVe[u
/*!
nbV֐͑Srbg̘ae[uTCYŏ]PȕłB
Srbgł邽߁ANX̃TCY傫ƃRXg傫Ȃ\B
ȂAL[vf͒ǉȂB
*/
template< class Key, class Value, class H = Hash< Key > > class HashMap{
public:
	///ftHgBsetCapacityĂ΂ȂƓȂ
	HashMap();
	///őeʂwBe[uTCY̓ftHgcapacityȏ̍ŏ̑fB
	explicit HashMap( int capacity, int tableSize = 0 );
	~HashMap();
	///ĊmہBgԂŌĂԂassertBclear()B
	void setCapacity( int capacity, int tableSize = 0 );
	///őeʎ擾
	int capacity() const;
	///݂̗vf擾
	int size() const;
	///S
	void clear();
	///ǉBǉꏊԂB̂łɂΖĖCe[^ԂB
	int add( const Key&, const Value& );
	///ǉBǉꏊԂB̂łɂΖĖCe[^ԂBlgetValueČォ珑ނƁB
	int add( const Key& );
	///BԂ̂̓Ce[^
	int find( const Key& ) const;
	///Ce[^w肵č폜B폜trueԂB
	bool remove( int position );
	///L[擾(͋֎~Ȃ̂const̂)
	const Key* key( int position ) const;
	///l擾(const)
	const Value* value( int position ) const;
	///l擾(const)
	Value* value( int position );
	///Ēl擾(const)
	const Value* operator[]( const Key& ) const;
	///Ēl擾(const)
	Value* operator[]( const Key& );
	//ȉPȃXgƂăANZXۂ̃C^[tFCXBЕ
	int next( int position ) const;
	int first() const;
	///position[B
	bool isEnd( int position ) const;
	///PȂzɃRs[BOsize()TCYneẅnƁB
	void copyTo( Value* ) const;
	///ArrayɃRs[B̂̂nB
	void copyTo( Array< Value >* ) const;
private:
	void operator=( const HashMap& ); //֎~
	HashMap( const HashMap& ); //Rs[RXgN^֎~

	int* mNexts;
	Key* mKeys;
	Value* mValues;
	Stack< int > mEmptyStack;
	int mCapacity;
	int mSize;
	int mTableSize;
};

} //namespace GameLib
#include "GameLib/Base/Impl/HashMapImpl.h" //g͂̒

#endif

