#ifndef INCLUDED_GAMELIB_IBINARYSTREAM_H
#define INCLUDED_GAMELIB_IBINARYSTREAM_H

#include "GameLib/Base/RefString.h"

namespace GameLib{
using namespace std;

class RefString;

///oCit@C̓ǂݍ݂yɂ邽߂̃NX
/*!
{IɃRs[͍sȂBāA͕̕ێĂKvB
*/
class IBinaryStream{
public:
	IBinaryStream( const char* );
	IBinaryStream( const char*, int size );
	IBinaryStream( const RefString& );
	~IBinaryStream();
	///߂l͓ǂ߂oCg
	int read( char*, int size );
	///egݍݐ^p̃o[WBs͈ɕԂ邪AnȂΉȂB
	int readInt( bool* succeeded = 0 );
	unsigned readUnsigned( bool* succeeded = 0 );
	short readShort( bool* succeeded = 0 );
	unsigned short readUnsignedShort( bool* succeeded = 0 );
	char readChar( bool* succeeded = 0 );
	unsigned char readUnsignedChar( bool* succeeded = 0 );

	bool isEnd() const;
	void setPosition( int = 0 );
	int position() const;
	int size() const;
private:
	const char* mBuffer;
	int mSize;
	int mPosition;
};

} //namespace GameLib

#endif