#ifndef INCLUDED_GAMELIB_OSTRINGSTREAM_H
#define INCLUDED_GAMELIB_OSTRINGSTREAM_H

#include <string>

namespace GameLib{
using namespace std;

class RefString;

///std::ostringstreamu邽߂̕Bxɏd_uA@\]ɂȂĂB
/*!
std::ostringstreamƂ̑_́A
Estr()ȂBget()ArraynĎoB
Eclear()őS
E@\Ȃ
*/
class OStringStream{
public:
	OStringStream( int blockSize = 1024 ); //newTCYB傫قǕׂ͌yA͐HB
	~OStringStream();
	int precision( int );
	OStringStream& operator<<( char );
	OStringStream& operator<<( unsigned char );
	OStringStream& operator<<( int );
	OStringStream& operator<<( unsigned );
	OStringStream& operator<<( short );
	OStringStream& operator<<( unsigned short );
	OStringStream& operator<<( float );
	OStringStream& operator<<( double );
	OStringStream& operator<<( const string& );
	OStringStream& operator<<( const char* );
	OStringStream& operator<<( char* );
	OStringStream& operator<<( const RefString& );
	OStringStream& operator<<( OStringStream& ( *f )( OStringStream& ) );
	void write( const char*, int size );
	template< class T > void write( const T& ); //oCi
	OStringStream& endl();
	OStringStream& hex();
	OStringStream& dec();

	void get( Array< char >* ) const;
	void get( string* ) const;
	int size() const;
	void clear();
private:
	OStringStream( const OStringStream& ); //Rs[RXgN^֎~
	void operator=( const OStringStream& ); //֎~
	class Impl;
	Impl* mImpl;
};

OStringStream& endl( OStringStream& );
OStringStream& hex( OStringStream& );
OStringStream& dec( OStringStream& );

} //namespace GameLib
#include "GameLib/Base/Impl/OStringStreamImpl.h"

#endif
