#ifndef INCLUDED_GAMELIB_TANK_H
#define INCLUDED_GAMELIB_TANK_H

#include "GameLib/Base/Array.h"

namespace GameLib{

///I܂ŃANZXA킩ȂAƂpr̂߂̂
/*!
߂ĈCɗC[WŃ^NƂAƂOΕWB
Iɂ͗eʒP(blockSize)ÂŃAP[gČpĂB

ANZXgetCurrent()Ŏ擾AtoNext()ŎցBrewind()ōŏANZXȂB
*/
template< class T > class Tank{
public:
	explicit Tank( int blockSize = 16 );
	~Tank();
	///ĊmہBgԂŌĂԂassertBclear()B
	void setBlockSize( int blockSize );
	///݂̗vf擾
	int size() const;
	///S
	void clear();
	///ɋŒǉB̂ւ̃|C^Ԃ̂ŁAݒ͂gƁB
	T* add();
	///ɒǉ
	void add( const T& );
	///
	void toNext();
	///Ił
	bool isEnd() const;
	///݂̗vf擾(const)
	T* get();
	///݂̗vf擾(const)
	const T* get() const;
	///ŏ̗vfɃ|C^߂
	void rewind();
	///PȂzɕϊBOsize()TCYneẅnƁB
	void copyTo( T* ) const;
	///ArrayɃRs[BłȂƓ{B
	void copyTo( Array< T >* ) const;
private:
	struct Block{
		Block* mNext; //̃m[h
		T* mElements; //z
	};
	void operator=( const Tank& ); //֎~
	Tank( const Tank& ); //Rs[RXgN^֎~

	//萔
	int mBlockSize; //Pʗ
	int mSize;
	Block mHead; //_~[

	Block* mLastBlock; //ŏIm[h
	int mLastPos; //ŏIm[ḧʒu
	Block* mCurrentBlock; //݂̃Ce[^
	int mCurrentPos; //m[hʒu
};

} //namespace GameLib
#include "GameLib/Base/Impl/TankImpl.h" //g͂̒

#endif
