#ifndef INCLUDED_GAMELIB_COLLISIONDETECTOR_H
#define INCLUDED_GAMELIB_COLLISIONDETECTOR_H

namespace GameLib{
namespace Math{
	class Vector3;
};
template< class T > class Array;
namespace Scene{
using namespace Math;

///Փ˔NX
/*
t[̎gpz肵ĂB
addœo^AdetectŌvZsČʂԂB
adďʂdetect񕪂Ȃ̂ŁA
t[add邱ƂɒӁB

󎎍iBk-d treeȂ̂ŌĂ݂ė~B
*/
class CollisionDetector{
public:
	///ʂ̔ԍyA
	struct Pair{
		int mId0, mId1;
	};
	static CollisionDetector create( int capacity, int maxLevel = -1 );
	///ڒǉBdetect񂾂LB߂l͌ʂɓĂIDB
	int add( const Vector3& sphereCenter, float sphereRadius );
	///o֐Badd̂͏Bɂ͌IDyAzB
	void detect( Array< Pair >* resultsOut );

	//ȉCɂȂĂ֐
	CollisionDetector();
	~CollisionDetector();
	CollisionDetector( const CollisionDetector& );
	operator void*() const;
	CollisionDetector& operator=( const CollisionDetector& );
	void release();
	bool operator==( const CollisionDetector& ) const;
	bool operator!=( const CollisionDetector& ) const;
private:
	class Impl;
	explicit CollisionDetector( Impl* );
	Impl* mImpl;
};

} //namespace Scene
} //namespace GameLib

#endif
