#ifndef INCLUDED_GAMELIB_SCENE_STRINGRENDERER_H
#define INCLUDED_GAMELIB_SCENE_STRINGRENDERER_H

namespace GameLib{

namespace Graphics{
	class Texture;
}
namespace Math{
	class Vector2;
}
using namespace Math;

namespace Scene{

class Font;

///`NXBDxw肠BŃ\[g܂B
class StringRenderer{
public:
	///ő升vAővswBassert
	static StringRenderer create( int charCapacity, int requestCapacity );
	///sNZWŎwBzfloat[0,1]ł邱Ƃɒ
	void add( 
		int x, 
		int y, 
		const char* string, 
		unsigned color = 0xffffffff, 
		bool wrapAround = false,
		float z = 0.f );
	///sNZfloatŏꏊw(x=[0,w], y=[0,h], z=[0,1] )
	void add( 
		const Vector2& position, 
		const char* string, 
		unsigned color = 0xffffffff, 
		bool wrapAroung = false, 
		float z = 0.f );
	///ߍ񂾗vꋓɕ`
	void draw();
	///tHgZbgBŒ͂ȂƎ͏ȂB
	void setFont( Font& );

	//ȉӎȂĂ
	StringRenderer();
	~StringRenderer();
	StringRenderer( const StringRenderer& );
	operator void*() const;
	StringRenderer& operator=( const StringRenderer& );
	void release();
	bool operator==( const StringRenderer& ) const;
	bool operator!=( const StringRenderer& ) const;
private:
	class Impl;
	Impl* mImpl;
};

} //namespace Scene
} //namespace GameLib

#endif
