#include "GameLib/Framework.h"
using namespace GameLib;

#include "State.h"
#include "File.h"

//֐vg^Cv
void mainLoop();

//O[oϐ
State* gState = 0;
const int gFrameInterval = 16; //16~bB62.5fpsB
unsigned gPreviousTime[ 10 ]; //10t[̎L^
int gCounter = 0; //C[v񐔂𐔂JE^

#define USE_SLEEP_FUNCTION //sleep֐gp

//[U֐BgmainLoop()Ɋۓ
namespace GameLib{
	void Framework::update(){
		mainLoop();
	}
}

void mainLoop(){
	//t[[g艻B擾߂΍t
	Framework f = Framework::instance();
	while ( ( f.time() - gPreviousTime[ 9 ] ) < gFrameInterval ){
#ifdef USE_SLEEP_FUNCTION
		f.sleep( 1 );
#endif
	}
	//t[[gvZ
	unsigned currentTime = f.time();
	unsigned frameInterval10 = currentTime - gPreviousTime[ 0 ];
	if ( gCounter % 60 == 0 ){ //60t[Ɉt[[g\
		cout << "frameInterval:" << frameInterval10/10;
		cout << " FrameRate:" << 10*1000/frameInterval10 << endl;
	}
	++gCounter;
	//XV
	for ( int i = 0; i < 9; ++i ){
		gPreviousTime[ i ] = gPreviousTime[ i + 1 ];
	}
	gPreviousTime[ 9 ] = currentTime;

	//ŏ̃t[͏B
	if ( !gState ){ 
		File file( "stageData.txt" );
		if ( !( file.getData() ) ){ //f[^ȂI
			cout << "stage file could not be read." << endl;
			return;
		}
		gState = new State( file.getData(), file.getSize() );
	}
	bool cleared = false;
	//C[v
	//NA`FbN
	if ( gState->hasCleared() ){
		cleared = true;
	}
	//͎擾
	int dx = 0;
	int dy = 0;
	if ( f.isKeyOn( 'a' ) ){
		dx -= 1;
	}else if ( f.isKeyOn( 's' ) ){
		dx += 1;
	}else if ( f.isKeyOn( 'w' ) ){
		dy -= 1;
	}else if ( f.isKeyOn( 'z' ) ){
		dy += 1;
	}
	//XV
	gState->update( dx, dy );
	//`
	gState->draw();

	if ( cleared ){
		//j̃bZ[W
		cout << "Congratulation! you win." << endl;
		delete gState;
		gState = 0;
	}
	//I
	if ( f.isKeyOn( 'q' ) ){
		f.requestEnd();
	}
	if ( f.isEndRequested() ){
		if ( gState ){
			delete gState;
			gState = 0;
		}
	}
}


