#include "GameLib/Framework.h"
using namespace GameLib;

#include "State.h"
#include "File.h"
#include "Image.h"

//֐vg^Cv
void mainLoop();
void game(); //Q[[v
void title(); //^Cgʃ[v

//V[PX
enum Sequence{
	SEQUENCE_GAME,
	SEQUENCE_TITLE,
};

//O[oϐ
State* gState = 0; //Q[
Image* gTitleImage = 0; //^Cgʉ摜
Sequence gSequence = SEQUENCE_TITLE; //V[PXԍ
int gCounter = 0;

//[U֐BgmainLoop()Ɋۓ
namespace GameLib{
	void Framework::update(){
		mainLoop();
	}
}

void mainLoop(){
	//t[[g
	Framework f = Framework::instance();
	f.setFrameRate( 60 ); //Ăׂ΂̂ʓ|Ȃ̂ŌĂł܂B

	if ( gCounter % 60 == 0 ){ //60t[Ɉt[[g\
		cout << " FrameRate:" << f.frameRate() << endl;
	}
	++gCounter;

	//V[PX
	switch ( gSequence ){
		case SEQUENCE_GAME: 
			game();
			break;
		case SEQUENCE_TITLE:
			title();
			break;
	}
	//I(qꂽA}EXŁ~{^@ꂽ)
	if ( f.isKeyOn( 'q' ) ){
		f.requestEnd();
	}
	if ( f.isEndRequested() ){
		SAFE_DELETE( gState );
		SAFE_DELETE( gTitleImage );
	}
	f.sleep(10);
}

//Q[[vBÕTv܂łGameLoop()̑唼ɈڐAB
void game(){
	//ŏ̃t[͏B
	if ( !gState ){ 
		File file( "stageData.txt" );
		if ( !( file.data() ) ){ //f[^ȂI
			cout << "stage file could not be read." << endl;
			return;
		}
		gState = new State( file.data(), file.size() );
	}
	bool cleared = false;
	//C[v
	//NA`FbN
	if ( gState->hasCleared() ){
		cleared = true;
	}
	//͎擾
	Framework f = Framework::instance();
	int dx = 0;
	int dy = 0;
	if ( f.isKeyOn( 'a' ) ){
		dx -= 1;
	}else if ( f.isKeyOn( 's' ) ){
		dx += 1;
	}else if ( f.isKeyOn( 'w' ) ){
		dy -= 1;
	}else if ( f.isKeyOn( 'z' ) ){
		dy += 1;
	}
	//XV
	gState->update( dx, dy );
	//`
	gState->draw();

	//NAȂnă^Cgʂ
	if ( cleared ){
		gSequence = SEQUENCE_TITLE;
		SAFE_DELETE( gState );
	}
}

void title(){
	//ŏ̃t[͏B
	if ( !gTitleImage ){
		gTitleImage = new Image( "title.dds" );
	}
	//͎擾
	if ( Framework::instance().isKeyOn( ' ' ) ){
		gSequence = SEQUENCE_GAME;
		SAFE_DELETE( gTitleImage );
		return;
	}
	gTitleImage->draw( 0, 0, 0, 0, gTitleImage->width(), gTitleImage->height() );
}

