#include "GameLib/GameLib.h"
#include "GameLib/Framework.h"
using namespace GameLib;

#include "Sequence/Game/Loading.h"
#include "Sequence/Game/Parent.h"
#include "Image.h"

namespace Sequence{
namespace Game{

//[hn߂̂update炱ł̓[h͊JnȂA
//u[hvƂ摜͂Ń[hB
Loading::Loading() : 
mImage( 0 ),
mCount( 0 ),
mStarted( false ){
	mImage = new Image( "data/image/loading.dds" );
}

Loading::~Loading(){
	SAFE_DELETE( mImage );
}

void Loading::update( Parent* parent ){
	if ( !mStarted ){
		//ǃ[ĥ͐eBȂȂStateĂ̂͐eB
		parent->startLoading();
		mStarted = true;
	}else if ( mCount == 60 ){ //1b҂
		parent->moveTo( Parent::SEQ_PLAY ); //PlayɈړ
	}

	//`
	mImage->draw();

	++mCount;
}

} //namespace Game
} //namespace Sequence