#include "GameLib/Framework.h"

//y`
struct Note{
	int mName; //h~B065Hz̃hB24^񒆂̃hB
	int mLength; // 1001bP
	int mVolume; // 0100
};

const int C = 24;
const int Cis = 25;
const int D = 26;
const int Dis = 27;
const int E = 28;
const int F = 29;
const int Fis = 30;
const int G = 31;
const int Gis = 32;
const int A = 33;
const int Ais = 34;
const int H = 35;

const Note gNotes[] = {
	{ E, 25, 20 },
	{ Dis, 25, 20 },

	{ E, 25, 20 },
	{ Dis, 25, 20 },
	{ E, 25, 20 },
	{ H-12, 25, 20 },
	{ D, 25, 20 },
	{ C, 25, 20 },

	{ A-12, 75, 20 },
	{ C-12, 25, 20 },
	{ E-12, 25, 20 },
	{ A-12, 25, 20 },

	{ H-12, 75, 20 },
	{ E-12, 25, 20 },
	{ Gis-12, 25, 20 },
	{ H-12, 25, 20 },

	{ C, 75, 20 },
};
const int gNoteNumber = 17;

void createSound( 
short* data, //o
int waveWidth, //g̕=
int note, //ԍ0261Hz̃hB12522Hz̃hBƌ̉ԍ
int sampleNumber ){ //f[^
	//ge[uB212捪(1.05946{)ÂĂ
	int frequencyTable[] = {
		261, 277, 293, 311, 329, 349, 370, 392, 415, 440, 466, 494,
	};
	int octave = note / 12; //IN^[uB̐g2{ĂB
	int f = frequencyTable[ note % 12 ]; //\ăh~߂

	//2IN^[uɂ炷
	octave -= 2;
	if ( octave >= 0 ){
		f <<= octave; //octave2Ȃ4{A͍Vtg2B
	}else{
		f >>= -octave;
	}

	//iɊ|搔vZ悤
	/*
	1 ~g = 44100 / (iŔg߂邩)
	2 (iŔg߂邩) = g̕ / iɊ|搔
	
	1,2̎A

	iɊ|搔 = g̕ * ~g / 44100
	*/

	//iɊ|鐔ɒ(̎Q)
	int m = waveWidth * f / 44100;

	//̓f[^߂邾
	for ( int i = 0; i < sampleNumber; ++i ){
		data[ i ] = static_cast< short >( (i*m) % waveWidth );
	}
}

bool gFirstFrame = true;

namespace GameLib{
	void Framework::update(){
		sleep( 16 );
		if ( gFirstFrame ){ //ŏ̃t[Ȃ
			gFirstFrame = false;
			short* wave = new short[ 44100 * 60 ]; //Ƃ肠1Bz񂪑傫newB

			//y߂܂B
			int time = 0;
			for ( int i = 0; i < gNoteNumber; ++i ){
				const Note& n = gNotes[ i ];
				createSound( 
					wave + time, 
					n.mVolume * 300,
					n.mName,
					n.mLength * 441 );
				time += n.mLength * 441;
			}
			//c0𖄂߂
			for ( int i = time; i < 44100 * 60; ++i ){
				wave[ i ] = 0;
			}
			playSound( wave, 44100 * 60 );
			SAFE_DELETE_ARRAY( wave );
		}
	}
}