#ifndef INCLUDED_MATRIX34_H
#define INCLUDED_MATRIX34_H

class Vector3;

class Matrix34{
public:
	Matrix34(); //ftHgŃRXgNg
	//ړs񐶐
	void setTranslation( const Vector3& );
	//gks񐶐
	void setScaling( const Vector3& );
	//]s񐶐X
	void setRotationX( double radian );
	//]s񐶐Y
	void setRotationY( double radian );
	//]s񐶐Z
	void setRotationZ( double radian );
	//xN^Ɗ|Z
	void multiply( Vector3* out, const Vector3& in ) const;
	//sƊ|Z
	void operator*=( const Matrix34& );
	//ړsƏZ
	void translate( const Vector3& );
	//gksƏZ
	void scale( const Vector3& );
	//X]sƏZ
	void rotateX( double radian );
	//Y]sƏZ
	void rotateY( double radian );
	//Z]sƏZ
	void rotateZ( double radian );
private:
	double m00, m01, m02, m03;
	double m10, m11, m12, m13;
	double m20, m21, m22, m23;
};

#endif
