#ifndef INCLUDED_PSEUDO_XML_ATTRIBUTE_H
#define INCLUDED_PSEUDO_XML_ATTRIBUTE_H

#include <string>
using namespace std;

namespace PseudoXml{

class Attribute{
public:
	Attribute();
	Attribute( const char* name, const char* value );
	~Attribute();

	void set( const char* name, const char* value );
	void set( const char* name, int value ); //intl
	void set( const char* name, double value ); //doublel
	void set( const char* name, const int* values, int number ); //intz
	void set( const char* name, const double* values, int number ); //doublez
	const string* value() const;
	const string* name() const;
	//s0ԂAƂ0Ă̂Ƃ͋ʂȂB
	int getIntValue() const;
	//s0.0ԂAƂ0.0Ă̂Ƃ͋ʂȂB
	double getDoubleValue() const;
	//߂l͎ۂɓǂ߂vf
	int getIntValues( int* out, int number ) const;
	//߂l͎ۂɓǂ߂vf
	int getDoubleValues( double* out, int number ) const;
private:
	string mName;
	string mValue;
};

} //namespace PseudoXml

#endif
