#include "List.h"

//_~[vfgƂŃR[hƂĂȒPɁI
static const int DUMMY_HEAD = 0;
static const int DUMMY_TAIL = 1;

//擪ƖʈȂ悤ɂƍHvĂB
List::List( int capacity ) : 
mNodes( 0 ),
mAddPosition( 0 ),
mCapacity( capacity + 2 ){
	mNodes = new Node[ capacity + 2 ];
	//0Ԃ͓ʁBŏ̗vf̑Oɂ_~[vfB
	Node* e;
	e = &mNodes[ DUMMY_HEAD ];
	e->mNext = 1;
	e->mPrev = -1;
	e->mValue = 0.0;
	//1ԂʁBŌ̗vf̂Ɍɂ_~[vfB
	e = &mNodes[ DUMMY_TAIL ];
	e->mNext = -1;
	e->mPrev = 0;
	e->mValue = 0.0;

	mAddPosition = 2; //2ԖڂǉJn
}

List::~List(){
	delete[] mNodes;
	mNodes = 0;
}

int List::addAfter( int position, double v ){
	//ꏊaddPosition
	Node* e = &mNodes[ mAddPosition ];
	//w̓zo
	Node* cur = &mNodes[ position ];
	//̓zo
	Node* next = &mNodes[ cur->mNext ];
	//li[
	e->mValue = v;
	e->mPrev = position; //wꏊO
	e->mNext = cur->mNext; //w̎̂
	//w̓z͑OɂȂ̂ŁA͑zɂȂ
	cur->mNext = mAddPosition;
	//w̎̓z͌ɂȂ̂ŁAO͑zɂȂ
	next->mPrev = mAddPosition;
	++mAddPosition;

	return mAddPosition - 1;
}

int List::addBefore( int position, double v ){
	//ꏊaddPosition
	Node* e = &mNodes[ mAddPosition ];
	//w̓zo
	Node* cur = &mNodes[ position ];
	//O̓zo
	Node* prev = &mNodes[ cur->mPrev ];
	//li[
	e->mValue = v;
	e->mPrev = cur->mPrev; //w̑O̓zO
	e->mNext = position; //w̓z
	//w̓z͌ɂȂ̂ŁAO͑zɂȂ
	cur->mPrev = mAddPosition;
	//w̑O̓z͑OɂȂ̂ŁA͑zɂȂ
	prev->mNext = mAddPosition;
	++mAddPosition;

	return mAddPosition - 1;
}

int List::addHead( double v ){
	return addBefore( first(), v ); //_~[vf̂łB
}

int List::addTail( double v ){
	return addAfter( last(), v ); //_~[vf̂ł
}

void List::remove( int position ){
	//w̓z
	Node* cur = &mNodes[ position ];
	//
	Node* next = &mNodes[ cur->mNext ];
	//O
	Node* prev = &mNodes[ cur->mPrev ];
	//O̓z̎AɂB
	prev->mNext = cur->mNext;
	//̓z̑OAOɂB
	next->mPrev = cur->mPrev;

	//܂BŌ悤ȂaddPosition߂ĂB
	//͑悤ɂȂ邩ȁB
	if ( position == mAddPosition - 1 ){
		--mAddPosition;
	}
}

void List::removeHead(){ //͂قƂǕʖB
	remove( first() );
}

void List::removeTail(){ //͂قƂǕʖB
	remove( last() );
}

double List::value( int position ) const {
	return mNodes[ position ].mValue;
}

int List::next( int position ) const {
	int r = mNodes[ position ].mNext;
	return ( r >= 2 ) ? r : -1; //_~[wĂ-1ɒu
}

int List::previous( int position ) const {
	int r = mNodes[ position ].mPrev;
	return ( r >= 2 ) ? r : -1; //_~[wĂ-1ɒu
}

int List::first() const {
	return mNodes[ DUMMY_HEAD ].mNext; //0Ԗڂ̓_~[擪Ȃ̂ŁA̎{̐擪
}

int List::last() const {
	return mNodes[ DUMMY_TAIL ].mPrev; //1Ԗڂ̓_~[Ȃ̂ŁȂO{̖
}
