#include "List.h"

//擪ƖʈȂ悤ɂƍHvĂB
List::List(){
	//ŏ肳ɑOɂ_~[vf
	mDummyHead.mNext = &mDummyTail;
	mDummyHead.mPrev = 0;
	mDummyHead.mValue = 0.0;
	//Ō̗vf̂Ɍɂ_~[vfB
	mDummyTail.mNext = 0;
	mDummyTail.mPrev = &mDummyHead;
	mDummyTail.mValue = 0.0;
}

List::~List(){
	//SĉȂƂȂ
	Node* p = first();
	while ( p ){
		Node* nxt = next( p );
		delete p;
		p = nxt;
	}
}

List::Node* List::addAfter( Node* cur, double v ){
	Node* e = new Node();
	//̓zo
	Node* nxt = cur->mNext;
	//li[
	e->mValue = v;
	e->mPrev = cur; //wꏊO
	e->mNext = nxt; //w̎̂
	//w̓z͑OɂȂ̂ŁA͑zɂȂ
	cur->mNext = e;
	//w̎̓z͌ɂȂ̂ŁAO͑zɂȂ
	nxt->mPrev = e;

	return e;
}

List::Node* List::addBefore( Node* cur, double v ){
	Node* e = new Node();
	//O̓zo
	Node* prev = cur->mPrev;
	//li[
	e->mValue = v;
	e->mPrev = prev; //w̑O̓zO
	e->mNext = cur; //w̓z
	//w̓z͌ɂȂ̂ŁAO͑zɂȂ
	cur->mPrev = e;
	//w̑O̓z͑OɂȂ̂ŁA͑zɂȂ
	prev->mNext = e;

	return e;
}

List::Node* List::addHead( double v ){
	return addBefore( first(), v ); //_~[vf̂łB
}

List::Node* List::addTail( double v ){
	return addAfter( last(), v ); //_~[vf̂ł
}

void List::remove( Node* cur ){
	//
	Node* nxt = cur->mNext;
	//O
	Node* prev = cur->mPrev;
	//O̓z̎AɂB
	prev->mNext = nxt;
	//̓z̑OAOɂB
	nxt->mPrev = prev;
	//
	delete cur;
	cur = 0;
}

void List::removeHead(){ //͂قƂǕʖB
	remove( first() );
}

void List::removeTail(){ //͂قƂǕʖB
	remove( last() );
}

double List::value( Node* p ) const {
	return p->mValue;
}

List::Node* List::next( Node* p ) const {
	Node* r = p->mNext;
	if ( r == &mDummyHead || r == &mDummyTail ){
		return 0;
	}else{
		return r;
	}
}

List::Node* List::previous( Node* p ) const {
	Node* r = p->mPrev;
	if ( r == &mDummyHead || r == &mDummyTail ){
		return 0;
	}else{
		return r;
	}
}

List::Node* List::first() const {
	return mDummyHead.mNext; //_~[擪̎{̐擪
}

List::Node* List::last() const {
	return mDummyTail.mPrev; //_~[̑O{̖
}
