#include <iostream>
#include <cstdlib> //rand(),atoi()
#include <limits>
#include <ctime> //clock()
using namespace std;

//ꏊ\
struct Position{
	double x;
	double y;
};

//ċA{
void search( 
int* minPath, 
int* path, 
int cn, 
int n, 
const Position* p, 
double currentLength, 
const Position& currentPos );

//ŒZ
double gMinLength = numeric_limits< double >::max(); //ƂĂ傫Ȑŏ

int main( int argc, char** argv ){
	if ( argc < 2 ){
		return 1; //G[
	}
	int n = atoi( argv[ 1 ] );

	//Ƃ̏ꏊ
	Position* positions = new Position[ n ];
	for ( int i = 0; i < n; ++i ){
		positions[ i ].x = rand();
		positions[ i ].y = rand();
		cout << i << " : " << positions[ i ].x << "," << positions[ i ].y << endl;
	}
	//ċAĂяoJn
	int* minPath = new int[ n ];
	int* path = new int[ n ];
	Position currentPos;
	currentPos.x = currentPos.y = 0.0; //ʒu
	double t0 = clock(); //Jn
	search( minPath, path, 0, n, positions, 0.0, currentPos );
	double t1 = clock(); //I

	cout << "Length : " << gMinLength << endl;
	for ( int i = 0; i < n; ++i ){
		cout << i << " " << minPath[ i ] << endl;
	}
	cout << "Calculation Time : " << ( t1 - t0 ) / CLOCKS_PER_SEC << endl;
	while(1);
	return 0;
}

void search( 
int* minPath, 
int* path, 
int cn, 
int n, 
const Position* p, 
double currentLength, 
const Position& currentPos ){
	for ( int i = 0; i < n; ++i ){
		//sȂꏊH
		bool found = false;
		for ( int j = 0; j < cn; ++j ){
			if ( path[ j ] == i ){
				found = true;
				break;
			}
		}
		if ( !found ){ //sȂ̂Ŏ͂֍s
			path[ cn ] = i;
			double dx = currentPos.x - p[ i ].x;
			double dy = currentPos.y - p[ i ].y;
			double l = currentLength + sqrt( dx * dx + dy * dy );
			if ( cn == n - 1 ){ //Ō܂ŗ̂ōċAĂяoO[oƔrBIB
				if ( l < gMinLength ){
					gMinLength = l;
					//oHۑ
					for ( int j = 0; j < n; ++j ){
						minPath[ j ] = path[ j ];
					}
					//݂̉\
					cout << l << " : ";
					for ( int j = 0; j < n; ++j ){
						cout << path[ j ] << ',';
					}
					cout << endl;
				}
			}else{
				search( minPath, path, cn + 1, n, p, l, p[ i ] );
			}
		}
	}
}
