#ifndef INCLUDED_VECTOR3_H
#define INCLUDED_VECTOR3_H

class Vector3{
public:
	//ȂRXgN^
	Vector3();
	//doubleRXgN^
	Vector3( double x, double y, double z );
	//Vector2RXgN^
	Vector3( const Vector3& );
	//ォ琔Zbg
	void set( double x, double y, double z );
	//Z
	void operator+=( const Vector3& );
	//Z
	void operator-=( const Vector3& );
	//Rs[
	void operator=( const Vector3& );
	//ZZbg
	void setAdd( const Vector3&, const Vector3& );
	//ZZbg
	void setSub( const Vector3&, const Vector3& );
	//Ϙa( this += a * b )B֗ł悭g
	void madd( const Vector3& a, double b );
	//xyza{
	void operator*=( double );
	//|ZZbg
	void setMul( const Vector3&, double );
	//̓Qbg
	double squareLength() const;
	//Qbg
	double length() const;
	//όvZ
	double dot( const Vector3& ) const;
	///this = crossProduct( a, b )
	void setCross( const Vector3& a, const Vector3& b );
	/// this = a * b + c
	void setMadd( const Vector3& a, double b, const Vector3& c );

	double x, y, z;
};

#endif
