#ifndef INCLUDED_GAMELIB_FRAMEWORK_H
#define INCLUDED_GAMELIB_FRAMEWORK_H

namespace GameLib{

class Framework{
public:
	Framework();
	///[U`֐BB
	void update();
	///CX^X擾
	static Framework instance();
	///ʕ擾
	int width() const;
	///ʍ擾
	int height() const;
	///VRAM擾
	unsigned* videoMemory();
	///FrameworkɏI߂o
	void requestEnd();
	///FrameworkɏI߂oĂ邩ׂ
	bool isEndRequested() const;

	//ȉCugp҂͒mȂĂ
	void start( void* windowHandle );
	void preUpdate();
	void postUpdate();
	static void create();
	static void destroy();
};

//ciñbp
class StandardInput{
public:
	StandardInput();
	StandardInput& operator>>( char& );
private:
	bool mPrevEnterOn;
};
extern StandardInput cin;

} //namespace GameLib

#include "GameLib/Base/DebugStream.h"

#endif
