#include "StdAfx.h"
#include "GameLib/GameLib.h"
#include "src/Tag.h"
#include "src/AttributeImpl.h"
#include "src/DocumentImpl.h"
#include "GameLib/Base/RefString.h"
using namespace std;

namespace GameLib{
namespace PseudoXml{

//ԑJڕ\B
/*
<ԔԍXg>
0:<̏B
1:Gg
2:Gǧ̋󔒁BAgr[g̊Ԃ̋󔒁B
3:Agr[g
4:=̏
5:Agr[gl(""̒g)
6:vf^OL/̏
7:Agr[g=̊Ԃ̋
8:Agr[gl(''̒g)
9:Agr[gl(܂ĂȂz)
10:Rg <! ... -->RgB{<!-- ... -->A!oiKŕʂȂAB(͂܂񂾂...<!ELEMENT݂Ȃ̂)
11:Rg-
12:Rg--
13:?Rg <? ... ?>Rg
14:?Rg?
E:I

<ԑJڃXg>
L:
c = [a-zA-Z0-9_] ܂蕁ʂ̕
s = ̏ɈȂc̕

0,/,0 I^OtOĂ
0,!,10 Rg
0,?,13 Rg
0,c,1 Ggŏ̈ꕶ
0,s,0 Ƃǂ܂
1,c,1 Ggɒǉ
1,>,E
1,s,2 Ggm
2,>,E
2,/,6 vf^O/
2,c,3 Agr[gŏ̈ꕶ
2,s,2 ǂݔ΂
3,=,4 =BAgr[gm
3,c,3 Agr[gɒǉ
3,s,7 󔒂ցBAgr[gm
4,",5 _uNHeCVBAgr[glɈڍs
4,/,8 VONHeCVBAgr[glɈڍs
4,c,9 Agr[glɈڍs
4,s,4 ǂݔ΂
5,",2 Agr[glmBAgr[gXgɒǉB
5,s,5 Agr[glɒǉ
6,>,E vfƂďI
6,s,6 ǂݔ΂
7,=,4 =
7,s,7 ǂݔ΂
8,',2 Agr[glmB
8,s,8 Agr[glɒǉ
9,/,6 vf^OB
9,>,E
9,c,9 Agr[glɒǉ
9,s,2 Agr[glm
10,-,11
10,s,10
11,-,12
11,s,10
12,>,E
12,s,10
13,?,14
13,s,13
14,>,E
14,s,13
*/
Tag::Tag( const char** p, const char* e, Document::Impl* document ) : 
mType( TYPE_BEGIN ),
mDocument( document ){
	//GgAAgr[g̖Oƒl̈ꎞIȊi[ꏊ
	const char* eName = 0;
	int eNameSize = 0;
	const char* aName = 0;
	int aNameSize = 0;
	const char* aValue = 0;
	int aValueSize = 0;

	int m = 0; //[hBmodeƂɂق񂾂낤Agp񐔂q킶Ȃ̂1ɂ
	bool end = false; //[v𔲂tO
	while ( *p < e ){
		bool wide = false; //{łH
		char c = **p;
		switch ( m ){
			case 0: //
				if ( c == '/' ){
					mType = TYPE_END;
				}else if ( c == '!' ){ //Rg
					mType = TYPE_COMMENT;
					m = 10;
				}else if ( c == '?'){
					mType = TYPE_COMMENT;
					m = 13;
				}else if ( isNormalChar( c, &wide ) ){
					eName = *p;
					eNameSize = 1;
					if ( wide && ( ( *p + 1 ) < e ) ){
						++eNameSize;
					}
					m = 1;
				}else{
					; //Ȃ
				}
				break;
			case 1: //Gg
				if ( c == '>' ){
					end = true;
				}else if ( isNormalChar( c, &wide ) ){
					++eNameSize;
					if ( wide && ( ( *p + 1 ) < e ) ){
						++eNameSize;
					}
				}else{
					m = 2; //Gg𔲂
				}
				break;
			case 2: //Gǧ̋
				if ( c == '>' ){
					end = true;
				}else if ( c == '/' ){
					mType = TYPE_BEGIN_END; //vf^Oł
					m = 6;
				}else if ( isNormalChar( c, &wide ) ){
					aName = *p;
					aNameSize = 1;
					if ( wide && ( ( *p + 1 ) < e ) ){
						++aNameSize;
					}
					m = 3;
				}else{
					; //Ȃ
				}
				break;
			case 3: //Agr[g
				if ( c == '=' ){
					m = 4;
				}else if ( isNormalChar( c, &wide ) ){
					++aNameSize;
					if ( wide && ( ( *p + 1 ) < e ) ){
						++aNameSize;
					}
				}else{
					m = 7; //󔒂
				}
				break;
			case 4: //=̏
				if ( c == '"' ){
					aValue = *p + 1;
					m = 5;
				}else if ( c == '\'' ){
					aValue = *p + 1;
					m = 8;
				}else if ( isNormalChar( c, &wide ) ){
					aValue = *p;
					aValueSize = 1;
					if ( wide && ( ( *p + 1 ) < e ) ){
						++aValueSize;
					}
					m = 9;
				}else{
					; //Ȃ
				}
				break;
			case 5: //Agr[gl
				if ( c == '"' ){
					m = 2; //Gǧ̋
					addAttribute( aName, aNameSize, aValue, aValueSize );
					aNameSize = aValueSize = 0;
				}else{
					++aValueSize;
					isNormalChar( c, &wide ); //Chǂm肽
					if ( wide && ( ( *p + 1 ) < e ) ){
						++aValueSize;
					}
				}
				break;
			case 6: //vf^O/o
				switch ( c ){
					case '>': end = true; break;
					default: break; //ǂݔ΂
				}
				break;
			case 7: //Agr[ǧ̋
				if ( c == '=' ){
					m = 4;
				}else if ( c == '>' ){
					addAttribute( aName, aNameSize, aValue, aValueSize );
					aNameSize = aValueSize = 0;
					end = true;
				}else if ( isNormalChar( c, &wide ) ){ //l̂ȂAgr[g
					addAttribute( aName, aNameSize, aValue, aValueSize );
					aNameSize = aValueSize = 0;
					//̃Agr[gɓ܂
					aName = *p;
					aNameSize = 1;
					if ( wide && ( ( *p + 1 ) < e ) ){
						++aNameSize;
					}
					m = 3;
				}else{
					; //Ȃ
				}
				break;
			case 8: //Agr[gl
				if ( c == '\'' ){
					m = 2; //Gǧ̋
					addAttribute( aName, aNameSize, aValue, aValueSize );
					aNameSize = aValueSize = 0;
				}else{
					++aValueSize;
					isNormalChar( c, &wide ); //Chǂm肽
					if ( wide && ( ( *p + 1 ) < e ) ){
						++aValueSize;
					}
				}
				break;
			case 9: //Agr[gl
				if ( c == '/' ){
					mType = TYPE_BEGIN_END; //vf^Oł
					m = 6;
					addAttribute( aName, aNameSize, aValue, aValueSize );
					aNameSize = aValueSize = 0;
				}else if ( c == '>' ){
					addAttribute( aName, aNameSize, aValue, aValueSize );
					aNameSize = aValueSize = 0;
					end = true;
				}else if ( isNormalChar( c, &wide ) ){
					++aValueSize;
					if ( wide && ( ( *p + 1 ) < e ) ){
						++aValueSize;
					}
				}else{
					m = 2; //Gǧ̋
					addAttribute( aName, aNameSize, aValue, aValueSize );
					aNameSize = aValueSize = 0;
				}
			case 10: //Rg
				switch ( c ){
					case '-': m = 11; break;
					default: break; //ǂݔ΂
				}
				break;
			case 11: //Rg-
				switch ( c ){
					case '-': m = 12; break;
					default: m = 10; break; //Rg
				}
				break;
			case 12: //Rg--
				switch ( c ){
					case '>': end = true; break;
					default: m = 10; break; //Rg
				}
				break;
			case 13: //?Rg
				switch ( c ){
					case '?': m = 14; break;
					default: break; //ǂݔ΂
				}
				break;
			case 14: //?Rg?
				switch ( c ){
					case '>': end = true; break;
					default: m = 13; break; //Rg
				}
				break;
		}
		*p += ( wide ) ? 2 : 1; //i߂
		if ( end ){ //Ił i߂ĂI邱Ƃɒӂ悤B̍sƋtɂȂƃoO
			break;
		}
	}
	mName.set( eName, eNameSize );
}

} //namespace PseudoXml
} //namespace GameLib
