#ifndef INCLUDED_GAMELIB_REFSTRING_H
#define INCLUDED_GAMELIB_REFSTRING_H

#include <string>

namespace GameLib{
using namespace std;

//Qƌ^NXB
/*!
QƂȂ߁Ãf[^jΔɊ댯ȂƂɂȂB
const char*݂̂ł͕sւȏꍇANULLI[s\ȏꍇŁA
\CɂȂꍇɌĎgƂ𐄏B
*/
class RefString{
public:
	RefString();
	RefString( const char*, int size );
	explicit RefString( const char* );
	~RefString();
	void set( const char*, int size );
	void operator=( const char* );
	void operator=( const string& );
	char operator[]( int i ) const;
	const char* get() const;
	int size() const;
	void setSize( int );
	///last͍Ō̂́̕B+1ȁBlast==-1Ǝn_ς
	void clamp( int first, int last = -1 ); 
	int find( char ) const; //O當TĈʒuԂBȂ-1B
	int rfind( char ) const; //ォ當TĈʒuԂBȂ-1B
	///QƐ敶Rs[ă|C^ԂBOdelete邱ƁB
	char* copyOriginal() const;

	bool operator==( const RefString& ) const;
	bool operator==( const char* ) const;
	bool operator==( const string& ) const;
	bool operator!=( const RefString& ) const;
	bool operator!=( const char* ) const;
	bool operator!=( const string& ) const;
	bool operator<( const RefString& ) const;
private:
	const char* mString;
	int mSize;
};

} //namespace GameLib

#endif