#ifndef INCLUDED_GAMELIB_FILEIO_MANAGER_H
#define INCLUDED_GAMELIB_FILEIO_MANAGER_H

#include <string>

namespace GameLib{
namespace FileIO{

class Manager{
public:
	//A[JCu̎g
	enum AccessMode{
		MODE_ARCHIVE_FIRST, //A[JCuDB
		MODE_DIRECT_FIRST, //ڃANZXDB
		MODE_ARCHIVE_ONLY, //A[JCû݁Bz鎞ɂ͂ɂĂB
	};
	///CX^X𓾂BAPManager().foo()ƏĂǂB
	static Manager instance();
	///nh󂯎炸ɏ݂sBs̕ʂ͂킩ȂB
	void write( const char* filename, const char* data, int size );
	///[hĂ̂XgɂēfoBfoOpBJR𒲂ׂ悤B
	std::string createListString() const;
	///eʌE̎wBwarning𒴂ƌxAerror𒴂ƃG[ɂBWl͗2GB
	void setLimit( int warning, int error );
	///G[NɎ~܂邩ǂBWtrueBc[~܂čȂfalseB
	void enableHaltOnError( bool );

	//ȉ[U͈ӎȂ
	static void create( 
		const char** archiveNames = 0, 
		int archiveNumber = 0, 
		AccessMode = MODE_DIRECT_FIRST );
	static void destroy();
};

} //namespace Sound
} //namespace GameLib

#endif
