#include "GameLib/Framework.h"
#include "GameLib/PseudoXml/Document.h"
#include "GameLib/PseudoXml/Element.h"
#include "GameLib/PseudoXml/Attribute.h"
using namespace GameLib;

PseudoXml::Document gDocument;
int gCount;


namespace GameLib{
	void Framework::configure( Configuration* ){}
	void Framework::update(){
		setFrameRate( 60 );
		if ( !gDocument ){
			//t@C琶
			gDocument = PseudoXml::Document::create( "data2.txt" );

			//1ēfoĂ݂
			using namespace PseudoXml;
			Document doc = Document::create();
			Element root = doc.root();
			//Ɉ
			root.setChildNumber( 1 );
			Element cameraData = root.child( 0 );
			cameraData.setName( "Data" );
			//f[^
			cameraData.setChildNumber( 2 );

			Element e;
			//
			e = cameraData.child( 0 );
			e.setName( "SomeElement0" );
			e.setAttributeNumber( 3 );
			e.attribute( 0 ).set( "name", "value" ); //l
			e.attribute( 1 ).set( "intValue", 1 ); //intl
			e.attribute( 2 ).set( "floatValue", 2.32f ); //floatl
			//
			e = cameraData.child( 1 );
			e.setName( "SomeElement1" );
			e.setAttributeNumber( 2 );
			int ia[ 5 ];
			for ( int i = 0; i < 5; ++i ){
				ia[ i ] = i;
			}
			e.attribute( 0 ).set( "intArray", ia, 5 ); //intz
			float fa[ 3 ];
			for ( int i = 0; i < 3; ++i ){
				fa[ i ] = 1.f / static_cast< float >( i + 1 );
			}
			e.attribute( 1 ).set( "floatArray", fa, 3 ); //floatz
			//coutɓfĂ݂
			string s;
			doc.convertToString( &s );
			cout << s << endl;
			//t@Cɂ
			doc.write( "dataCreated.txt", false );
		}else if ( gDocument.isReady() ){ //ǂݍݏI
			//񉻂coutɏoĂ݂B
			string s;
			gDocument.convertToString( &s );
			cout << s << endl;
			//łɃt@CɂfĂ݂B̂oĂ邩H
			gDocument.write( "dataOut.txt" );
			gDocument.release(); //ǂݏIAˁB
			requestEnd(); //IB
		}
	}
}
