#ifndef INCLUDED_GAMELIB_SOUND_PLAYER_H
#define INCLUDED_GAMELIB_SOUND_PLAYER_H

namespace GameLib{
namespace Sound{

class Wave;

class Player{
public:
	static Player create( Wave );
	///Xg[~OĐpPlayer
	static Player create( int bitsPerSample, int bufferSizeInByte, int frequency, int channelNumber );

	///ĐB[vĐtruen
	void play( bool looping = false );
	void stop();
	///{[ݒ(100őA0ŏ)
	void setVolume( int volume );
	bool isPlaying() const; //ĐłH

	///Xg[~Oobt@ɏށBĐʒu߂ÂĎsꍇfalseԂBтB
	bool write( int position, const char* data, int size );
	///Xg[~Oobt@ɖށBĐʒu߂ÂĎsꍇfalseԂBтB
	bool fillSilence( int position, int size );
	///Đ̃obt@ʒuoCgPʂŕԂ
	int position() const;

	//ȉ[U͈ӎȂ֐Q
	Player();
	Player( const Player& );
	~Player();
	operator void*() const;
	Player& operator=( const Player& );
	void release();
	bool operator==( const Player& ) const;
	bool operator!=( const Player& ) const;
private:
	class Impl;
	Impl* mImpl;
};

} //namespace Sound
} //namespace GameLib

#endif
