#ifndef INCLUDED_GAMELIB_HASHMULTIMAP_H
#define INCLUDED_GAMELIB_HASHMULTIMAP_H

#include "GameLib/Base/Stack.h"
#include "GameLib/Base/Hash.h"
#include "GameLib/Base/Array.h"

namespace GameLib{

///EeʎwnbVe[u
/*!
nbV֐͑Srbg̘ae[uTCYŏ]PȕłB
Srbgł邽߁ANX̃TCY傫ƃRXg傫Ȃ\B
ȂAL[vfǉBfind͓L[̂̐擪ԂB
getNextňقȂL[̂̂Ԃ܂Ń[vŉ񂷂ƁB
AKisEnd()ĂŔ͈͊OłȂƂmF邱ƁB
*/
template< class Key, class Value, class H = Hash< Key > > class HashMultiMap{
public:
	///ftHgBsetCapacityĂ΂ȂƓȂ
	HashMultiMap();
	///őeʂwBe[uTCY̓ftHgcapacityȏ̍ŏ̑fB
	explicit HashMultiMap( int capacity, int tableSize = 0 );
	~HashMultiMap();
	///ĊmہBgԂŌĂԂassertBclear()B
	void setCapacity( int capacity, int tableSize = 0 );
	///őeʎ擾
	int capacity() const;
	///݂̗vf擾
	int size() const;
	///S
	void clear();
	///ǉBǉꏊԂB
	int add( const Key&, const Value& );
	///ǉBǉꏊԂBlgetValueČォ珑ނƁB
	int add( const Key& );
	///BԂ̂̓Ce[^BL[̐擪B
	int find( const Key& ) const;
	///Ce[^w肵č폜B폜trueԂB
	bool remove( int position );
	///L[擾(͋֎~Ȃ̂const̂)
	const Key* key( int position ) const;
	///l擾(const)
	const Value* value( int position ) const;
	///l擾(const)
	Value* value( int position );
	//ȉPȃXgƂăANZXۂ̃C^[tFCXBЕ
	int next( int position ) const;
	int first() const;
	///position[B
	bool isEnd( int position ) const;
	///PȂzɕϊBOsize()TCYneẅnƁB
	void copyTo( Value* ) const;
	///ArrayɃRs[B̂̂nB
	void copyTo( Array< Value >* ) const;
private:
	void operator=( const HashMultiMap& ); //֎~
	HashMultiMap( const HashMultiMap& ); //Rs[RXgN^֎~

	int* mNexts;
	Key* mKeys;
	Value* mValues;
	Stack< int > mEmptyStack;
	int mCapacity;
	int mSize;
	int mTableSize;
};

} //namespace GameLib
#include "GameLib/Base/Impl/HashMultiMapImpl.h" //g͂̒

#endif

