#ifndef INCLUDED_GAMELIB_LIST_H
#define INCLUDED_GAMELIB_LIST_H

#include "GameLib/Base/Stack.h"
#include "GameLib/Base/Array.h"

namespace GameLib{

///new̃I[o[փbhɑςȂ̂߂̑oXg
template< class T > class List{
public:
	List();
	explicit List( int capacity );
	~List();
	///ォTCYwBgƎʁBclear()悤B
	void setCapacity( int capacity );
	int capacity() const;
	//ǉ SďꏊԂ
	int addBefore( int position, const T& value ); //wꏊ̑Oɒǉ
	int addAfter( int position, const T& value ); //wꏊ̌ɒǉ
	int addHead( const T& value ); //擪ǉ
	int addTail( const T& value ); //ǉ
	//폜
	void remove( int position ); //wꏊ폜
	void removeHead(); //擪폜
	void removeTail(); //폜
	void clear(); //S폜
	///l擾(const)
	const T* value( int position ) const;
	///l擾(const)
	T* value( int position );
	///[ǂisEnd()ŊmF
	int next( int position ) const;
	///[ǂisEnd()ŊmF
	int previous( int position ) const;
	int first() const;
	int last() const;
	///position[B
	bool isEnd( int position ) const;
	///PȂzɕϊBOsize()TCYneẅnƁB
	void copyTo( T* ) const;
	///ArrayɃRs[B̂̂nB
	void copyTo( Array< T >* ) const;
private:
	struct Node{
		int mNext;
		int mPrev;
	};
	List( const List& ); //Rs[RXgN^֎~
	void operator=( const List& ); //֎~

	T* mValues;
	Node* mNodes;
	Stack< int > mEmptyStack;
	int mCapacity;
	int mSize;
};

} //namespace GameLib
#include "GameLib/Base/Impl/ListImpl.h" //g͂̒

#endif

