#ifndef INCLUDED_GAMELIB_POOL_H
#define INCLUDED_GAMELIB_POOL_H

namespace GameLib{

///^̒uꏊBςnew팸邽߂ɗpB
/*!
mۂ邽߂ɂǍ͉̑łȂƂɒӂ邱ƁB
܂As\Bł̂͑S̉łB
*/
template< class T > class Pool{
public:
	explicit Pool( int defaultBlockSize = 16 );
	~Pool();
	///WubNύXB
	void setDefaultBlockSize( int blockSize );
	///S
	void clear();
	///nm
	T* allocate( int n = 1 );
	///nRs[RXgNg
	T* allocate( const T*, int n = 1 );
private:
	struct Block{
		Block* mNext; //̃ubN
		T* mElements; //z
		int mUsedNumber; //gꂽ
		int mSize; //ubÑTCY
	};
	void operator=( const Pool& ); //֎~
	Pool( const Pool& ); //Rs[RXgN^֎~

	//萔
	int mDefaultBlockSize; //Pʗ
	Block mHead; //_~[m[hB
	Block* mLastBlock; //ŏIm[h
};

} //namespace GameLib
#include "GameLib/Base/Impl/PoolImpl.h" //g͂̒

#endif
