#ifndef INCLUDED_GAMELIB_QUEUE_H
#define INCLUDED_GAMELIB_QUEUE_H

namespace GameLib{

///L[BvfE𒴂ȂΏz̂ł܂łgB
template< class T > class Queue{
public:
	///ftHgBTCYAőeʂ0B
	Queue();
	///őeʂwB
	explicit Queue( int capacity );
	~Queue();
	///ĊmہBgԂŌĂԂassertBclear()B
	void setCapacity( int size );
	///őeʎ擾
	int capacity() const;
	///݂̗vf擾
	int size() const;
	///S
	void clear();
	///ɋŒǉB̂ւ̃|C^Ԃ̂ŁAݒ͂gƁB
	T* pushBack();
	///ɒǉ
	void pushBack( const T& );
	///擪폜
	void popFront();
	///擪폜(̂Ă̂̃Rs[擾)
	void popFront( T* out );
	///擪擾(const)
	const T* front() const;
	///擪擾(const)
	T* front();
private:
	void operator=( const Queue& ); //֎~
	Queue( const Queue& ); //Rs[RXgN^֎~

	T* mElements;
	int mSize;
	int mCapacity;
	int mFront;
};

} //namespace GameLib
#include "GameLib/Base/Impl/QueueImpl.h" //g͂̒

#endif

