#ifndef INCLUDED_GAMELIB_FILEIO_INFILE_H
#define INCLUDED_GAMELIB_FILEIO_INFILE_H

namespace GameLib{
namespace FileIO{

///ǂݍ݃t@Cnh
class InFile{
public:
	///t@C[hJn
	static InFile create( const char* filename );
	///[heʃQbg
	int size() const;
	///[heQbg
	const char* data() const; 
	///[hIH
	bool isFinished() const;
	///G[oĂ܂H
	bool isError() const;
	//lQbg֐Q
	int getInt( int position ) const;
	unsigned getUnsigned( int position ) const;
	short getShort( int position ) const;
	unsigned short getUnsignedShort( int position ) const;

	//ȉ[U͈ӎȂ֐Q
	InFile();
	InFile( const InFile& );
	~InFile();
	operator void*() const;
	InFile& operator=( const InFile& );
	void release();
	bool operator==( const InFile& ) const;
	bool operator!=( const InFile& ) const;

	class Impl;
private:
	Impl* mImpl;
};

} //namespace FileIO
} //namespace GameLib

#endif
