#ifndef INCLUDED_GAMELIB_COLLISIONMESH_H
#define INCLUDED_GAMELIB_COLLISIONMESH_H

namespace GameLib{
namespace PseudoXml{
	class ConstElement;
}
namespace Math{
	class Vector3;
};
namespace Scene{
using namespace Math;

///Փ˔pOp`WNX
/*
ContainerVertexBufferIndexBufferSgĈ̎Op`W`B
BatchAnimationX͒PɌȂB
*/
class CollisionMesh{
public:
	///jZXMLt@CRXgNg
	static CollisionMesh create( const char* filename );
	///jZXML̃Gg(Container)RXgNg
	static CollisionMesh create( PseudoXml::ConstElement );
	///[hImBt@CꍇtrueԂ邱ƂmFĂgƁB
	bool isReady();
	///ƌB
	bool isIntersect( const Vector3& lineOrigin, const Vector3& lineVector ) const;
	///ƌBŏɓtimeOutɓBtrueԂB
	bool getIntersection( 
		float* timeOut, //0|C^ȂԂȂ
		Vector3* normalOut, //0|C^ȂԂȂ
		const Vector3& lineOrigin, 
		const Vector3& lineVector ) const;

	CollisionMesh();
	~CollisionMesh();
	CollisionMesh( const CollisionMesh& );
	operator void*() const;
	CollisionMesh& operator=( const CollisionMesh& );
	void release();
	bool operator==( const CollisionMesh& ) const;
	bool operator!=( const CollisionMesh& ) const;
private:
	class Impl;
	explicit CollisionMesh( Impl* );
	Impl* mImpl;
};

} //namespace Scene
} //namespace GameLib

#endif
