#ifndef INCLUDED_GAMELIB_FRAMEWORK_H
#define INCLUDED_GAMELIB_FRAMEWORK_H

namespace GameLib{

class Framework{
public:
	Framework();
	///[U`֐BB
	void update();
	///CX^X擾
	static Framework instance();
	///ʕ擾
	int width() const;
	///ʍ擾
	int height() const;
	///VRAM擾
	unsigned* videoMemory();
	///FrameworkɏI߂o
	void requestEnd();
	///FrameworkɏI߂oĂ邩ׂ
	bool isEndRequested() const;
	///~bPʂŐQ
	void sleep( int milliSeconds ) const;
	///擾(~bP)
	unsigned time() const;
	///t[[g擾
	int frameRate() const;
	///t[[gݒ(ő҂[v񂵂Ă)
	void setFrameRate( int );
	///Ot[Ԏ擾(~bP)
	int previousFrameInterval() const;
	///_Qbg
	int getRandom( int max = 0 );
	//
	void drawDebugString( 
		int column, //(x)
		int row, //s(y)
		const char* string, 
		unsigned color = 0xffffffff );

	//ȉCugp҂͒mȂĂ
	void start( void* windowHandle );
	void preUpdate();
	void postUpdate();
	static void create();
	static void destroy();
};

} //namespace GameLib

#include "GameLib/GameLib.h"

#endif
