#include <iostream>
using namespace std;

//# _ .S[ oubN pl
const char gStageData[] = "\
########\n\
# .. p #\n\
# oo   #\n\
#      #\n\
########";
const int gStageWidth = 8;
const int gStageHeight = 5;

enum Object{
	OBJ_SPACE,
	OBJ_WALL,
	OBJ_GOAL,
	OBJ_BLOCK,
	OBJ_BLOCK_ON_GOAL,
	OBJ_MAN,
	OBJ_MAN_ON_GOAL,

	OBJ_UNKNOWN,
};

//֐vg^Cv
void initialize( Object* state, int w, int h, const char* stageData );
void draw( const Object* state, int w, int h );
void update( Object* state, char input, int w, int h );
bool checkClear( const Object* state, int w, int h );

int main(){
	//ꎟzł闝R͖{Q
	Object* state = new Object[ gStageWidth * gStageHeight ]; //Ԕzm

	initialize( state, gStageWidth, gStageHeight, gStageData ); //Xe[W
	//C[v
	while ( true ){
		//܂`
		draw( state, gStageWidth, gStageHeight );
		//NA`FbN
		if ( checkClear(state, gStageWidth, gStageHeight ) ){
			break; //NA`FbN
		}
		//͎擾
		cout << "a:left s:right w:up z:down. command?" << endl; //
		char input;
		cin >> input;
		//XV
		update( state, input, gStageWidth, gStageHeight ); 	
	}
	//j̃bZ[W
	cout << "Congratulation's! you won." << endl;
	//n
	delete[] state;
	state = 0;

	//Visual Studiosl̂߂ɖ[vBR}hCCtrl-CŏIĂB
	while( true ){
		;
	} 
	return 0;
}

//---------------------ȉ֐`------------------------------------------


//g邾낤ƍndlɂAgĂȂ̂ŖO(height)RgAEgĂB
void initialize( Object* state, int width, int /* height */, const char* stageData ){	
	const char* d = stageData; //ǂݍ݃|C^
	int x = 0;
	int y = 0;
	while ( *d != '\0' ){ //NULLłȂ
		Object t; //ɈӖ͂Ȃg񐔂ϐɎ͗ǂtgBtemporary̗BԂ悭ȂKAʂɒOɂēǂ݂ɂ̂蕨낤B
		switch ( *d ){
			case '#': t = OBJ_WALL; break;
			case ' ': t = OBJ_SPACE; break;
			case 'o': t = OBJ_BLOCK; break;
			case 'O': t = OBJ_BLOCK_ON_GOAL; break;
			case '.': t = OBJ_GOAL; break;
			case 'p': t = OBJ_MAN; break;
			case 'P': t = OBJ_MAN_ON_GOAL; break;
			case '\n': x = 0; ++y; t = OBJ_UNKNOWN; break; //s
			default: t = OBJ_UNKNOWN; break;
		}
		++d;
		if ( t != OBJ_UNKNOWN ){ //mȂȂ疳̂łif
			state[ y*width + x ] = t; //
			++x;
		}
	}
}

void draw( const Object* state, int width, int height ){
	const char font[] = {' ', '#', '.', 'o', 'O', 'p', 'P'}; //Object񋓂̏
	for ( int y = 0; y < height; ++y ){
		for ( int x=0; x < width; ++x ){
			Object o = state[ y*width + x ];
			cout << font[ o ];
		}
		cout << endl;
	}
}

//͂ق̊֐łstateƂĂ邪A܂ɕpɂɎĝ
//Zsōς܂ĂBw,hꂼwidth,heightłB
void update( Object* s, char input, int w, int h ){
	//ړɕϊ(ddifferencełdeltałDȕ̗Ǝvė~)
	int dx = 0; 
	int dy = 0;
	switch ( input ){
		case 'a': dx = -1; break; //
		case 's': dx = 1; break; //E
		case 'w': dy = -1; break; //BY͉vX
		case 'z': dy = 1; break; //B
	}
	//lW
	int i = -1;
	for ( i = 0; i < w * h; ++i ){
		if ( s[ i ] == OBJ_MAN || s[ i ] == OBJ_MAN_ON_GOAL ){
			break;
		}
	}
	int x = i % w; //x͕Ŋ܂
	int y = i / w; //y͕Ŋ

	//ړ
	//ړW(tɈӖ͂ȂB߂Ȃ)
	int tx = x + dx;
	int ty = y + dy;
	//W̍őŏ`FbNBOĂΕs
	if ( tx < 0 || ty < 0 || tx >= w || ty >= h ){
		return;
	}
	//A.̕󔒂܂̓S[BlړB
	int p = y*w + x; //lʒu
	int tp = ty*w + tx; //^[Qbgʒu(TargetPosition)
	if ( s[ tp ] == OBJ_SPACE || s[ tp ] == OBJ_GOAL ){
		s[ tp ] = ( s[ tp ] == OBJ_GOAL ) ? OBJ_MAN_ON_GOAL : OBJ_MAN; //S[ȂS[̐l
		s[ p ] = ( s[ p ] == OBJ_MAN_ON_GOAL ) ? OBJ_GOAL : OBJ_SPACE; //ƂƃS[ȂS[
	//B.̕B̎̃̕}X󔒂܂̓S[łΈړB
	}else if ( s[ tp ] == OBJ_BLOCK || s[ tp ] == OBJ_BLOCK_ON_GOAL ){
		//2}X悪͈͓`FbN
		int tx2 = tx + dx;
		int ty2 = ty + dy; 
		if ( tx2 < 0 || ty2 < 0 || tx2 >= w || ty2 >= h ){ //Ȃ
			return;
		}

		int tp2 = ( ty + dy )*w + ( tx + dx ); //2}X
		if ( s[ tp2 ] == OBJ_SPACE || s[ tp2 ] == OBJ_GOAL ){
			//ւ
			s[ tp2 ] = ( s[ tp2 ] == OBJ_GOAL ) ? OBJ_BLOCK_ON_GOAL : OBJ_BLOCK;
			s[ tp ] = ( s[ tp ] == OBJ_BLOCK_ON_GOAL ) ? OBJ_MAN_ON_GOAL : OBJ_MAN;
			s[ p ] = ( s[ p ] == OBJ_MAN_ON_GOAL ) ? OBJ_GOAL : OBJ_SPACE;
		}
	}
}

//ubN݂̂Ȃ΃NAĂB
bool checkClear( const Object* s, int width, int height ){
	for ( int i = 0; i < width*height; ++i ){
		if ( s[ i ] == OBJ_BLOCK ){
			return false;
		}
	}
	return true;
}
