#include "GameLib/Framework.h"
using namespace GameLib;

#include "State.h"
#include "File.h"

//֐vg^Cv
void mainLoop();

//O[oϐ
State* gState = 0;

//[U֐BgmainLoop()Ɋۓ
namespace GameLib{
	void Framework::update(){
		mainLoop();
	}
}

void mainLoop(){
	//~{^ĂH
	if ( Framework::getInstance().isEndRequested() ){
		if ( gState ){
			delete gState;
			gState = 0;
		}
		return;
	}
	//ŏ̃t[͏Bŏ̏Ԃ`悵ďIB
	if ( !gState ){ 
		File file( "stageData.txt" );
		if ( !( file.getData() ) ){ //f[^ȂI
			cout << "stage file could not be read." << endl;
			return;
		}
		gState = new State( file.getData(), file.getSize() );
		//`
		gState->draw();
		return; //̂܂܏I
	}
	bool cleared = false;
	//C[v
	//NA`FbN
	if ( gState->hasCleared() ){
		cleared = true;
	}
	//͎擾
	cout << "a:left s:right w:up z:down. command?" << endl; //
	char input;
	cin >> input;
	//I
	if ( input == 'q' ){
		delete gState;
		gState = 0;
		Framework::getInstance().requestEnd();
		return;
	}
	//XV
	gState->update( input );
	//`
	gState->draw();

	if ( cleared ){
		//j̃bZ[W
		cout << "Congratulation! you win." << endl;
		delete gState;
		gState = 0;
	}
}


