#include "GameLib/Framework.h"

class Square{
public:
	void set( int x, int y, int halfSize ){
		mX = x;
		mY = y;
		mHalfSize = halfSize;
	}
	//10001t[Pʂ̓ԂB01000܂ł̐ԂA
	//0ȂړJn̏uԂɓƂA1000͓ȂƂӖB
	int getIntersectionTime( int dx, int dy, const Square& b ) const {
		//_ɂ邩̂悤ɓړB
		int x = b.mX - mX;
		int y = b.mY - mY;
		//̑x0ɂȂ悤ɁAɑxtB
		int vx = -dx;
		int vy = -dy;
		//傫ɏW߂B`Ȃ̂ŒPɑΗǂB
		int s = mHalfSize + b.mHalfSize;
		//̏󋵂(x,y)+t(vx,vy)4{̒
		//x = -s, x = s, y = -s, y = s
		//ɓ鎞vZB

		int tx0, tx1, ty0, ty1; //4̎
		//x+t*vx=-sx+t*vx=sA
		if ( vx == 0 ){
			//Ԃǂ𒲂ׂ
			if ( -s < x && x < s ){
				tx0 = -1000; //ߋɂAɔÄӖ
				tx1 = 1000;
			}else{ //łȂΖiȂ
				tx0 = tx1 = 1000;
			}
		}else{
			tx0 = ( -s - x ) * 1000 / vx;
			tx1 = ( s - x ) * 1000 / vx;
		}
		//y+t*vy=-sy+t*vy=sA
		if ( vy == 0 ){
			//Ԃǂ𒲂ׂ
			if ( -s < y && y < s ){
				ty0 = -1000; //ߋɂAɔÄӖ
				ty1 = 1000;
			}else{ //łȂΖiȂ
				ty0 = ty1 = 1000;
			}
		}else{
			ty0 = ( -s - y ) * 1000 / vy;
			ty1 = ( s - y ) * 1000 / vy;
		}
		//tx0,ty0قɂBオyɂȂB
		int t;
		if ( tx0 > tx1 ){
			t = tx0;
			tx0 = tx1;
			tx1 = t;
		}
		if ( ty0 > ty1 ){
			t = ty0;
			ty0 = ty1;
			ty1 = t;
		}
		t = 1000; //Փˎ
		//tx0ɂē邩`FbN
		if ( tx0 >= 0 && tx0 < 1000 ){
			//\莞ɂyԂɂ΂łB
			//ty0<=tx0<=ty1𖞂΂B
			if ( ty0 <= tx0 && tx0 <= ty1 && tx0 < t ){
				t = tx0;
			}
		}
		//tx1
		if ( tx1 >= 0 && tx1 < 1000 ){
			if ( ty0 <= tx0 && tx0 <= ty1 && tx1 < t ){
				t = tx1;
			}
		}
		//ty0
		if ( ty0 >= 0 && ty0 < 1000 ){
			if ( tx0 <= ty0 && ty0 <= tx1 && ty0 < t ){
				t = ty0;
			}
		}
		//ty1
		if ( ty1 >= 0 && ty1 < 1000 ){
			if ( tx0 <= ty0 && ty0 <= tx1 && ty1 < t ){
				t = ty1;
			}
		}
		return t;
	}
	int mX;
	int mY;
	int mHalfSize;
};
bool gFirstFrame = true;
Square gPlayer; //L̂
Square gWall; //

namespace GameLib{
	void Framework::update(){
		if ( gFirstFrame ){
			setFrameRate( 60 );
			gFirstFrame = false;
			gPlayer.set( 16, 16, 16 );
			gWall.set( 160, 120, 16 );
		}
		//ړʃQbg
		int dx = 0;
		int dy = 0;
		if ( isKeyOn( 'a' ) ){
			dx = -7;
		}else if ( isKeyOn( 's' ) ){
			dx = 7;
		}
		if ( isKeyOn( 'w' ) ){
			dy = -7;
		}else if ( isKeyOn( 'z' ) ){
			dy = 7;
		}
		unsigned* vram = videoMemory();
		//Փˏ
		unsigned color = 0xffff0000;
		int time = gPlayer.getIntersectionTime( dx, dy, gWall );
		if ( time < 1000 ){
			color = 0xffffffff;
		}
		//ړ
		gPlayer.mX += ( dx * time ) / 1000;
		gPlayer.mY += ( dy * time ) / 1000;
		//`
		//UNA
		for ( int i = 0; i < width() * height(); ++i ){
			vram[ i ] = 0;
		}
		//Ȃق`
		for ( int y = 0; y < 32; ++y ){
			for ( int x = 0; x < 32; ++x ){
				int tx = x + gWall.mX - 16;
				int ty = y + gWall.mY - 16;
				vram[ ty * width() + tx ] = 0xff0000ff; 
			}
		}
		//ق`
		for ( int y = 0; y < 32; ++y ){
			for ( int x = 0; x < 32; ++x ){
				int tx = x + gPlayer.mX - 16;
				int ty = y + gPlayer.mY - 16;
				vram[ ty * width() + tx ] = color; 
			}
		}
	}
}