#include "GameLib/GameLib.h"
#include "GameLib/Input/Manager.h"
#include "GameLib/Input/Keyboard.h"
using namespace GameLib;

#include "Sequence/Game/Play.h"
#include "Sequence/Game/Clear.h"
#include "Sequence/Game/Failure.h"
#include "Sequence/Game/Judge.h"
#include "Sequence/Game/Pause.h"
#include "Sequence/Game/Parent.h"
#include "Game/State.h"
#include "Pad.h"

namespace Sequence{
namespace Game{

Play::Play(){ //Ȃ
}

Play::~Play(){ //Ȃ
}

//Q[{
Child* Play::update( Parent* parent ){
	Child* next = this;
	Input::Keyboard kb = Input::Manager::instance().keyboard();

	State* state = parent->state();

	bool cleared = state->hasCleared();
	bool die1P = !state->isAlive( 0 );
	bool die2P = !state->isAlive( 1 );
	//Ƃ肠foOR}hŃeXgB
	if ( kb.isTriggered( '1' ) ){ //2PE
		die2P = true;
	}else if ( kb.isTriggered( '2' ) ){ //1PE
		die1P = true;
	}else if ( kb.isTriggered( 'c' ) ){
		cleared = true;
	}
	//SPACEꂽ|[Y֍s
	//NAȂ֕
	if ( parent->mode() == Parent::MODE_1P ){
		if ( cleared && !die1P ){
			parent->goToNextStage();
			next = new Clear;
		}else if ( die1P ){
			parent->reduceLife();
			next = new Failure;
		}
	}else{ //lp
		if ( die1P || die2P ){ //ǂłΏs
			next = new Judge;
			if ( die1P && die2P ){
				parent->setWinner( Parent::PLAYER_NONE ); //S
			}else if ( die1P ){
				parent->setWinner( Parent::PLAYER_2 );
			}else{
				parent->setWinner( Parent::PLAYER_1 );
			}
		}
	}
	if ( ( next == this ) && Pad::isTriggered( Pad::B ) ){ //B{^Ń|[Y֍sB܂ڂĂȂ
		next = new Pause;
	}
	//XV
	state->update();
	//`
	state->draw();

	return next;
}

} //namespace Game
} //namespace Sequence
