#ifndef INCLUDED_SOUND_MANAGER_H
#define INCLUDED_SOUND_MANAGER_H

#include "GameLib/Sound/Wave.h"
#include "GameLib/Sound/Player.h"

//VOg
class SoundManager{
public:
	static SoundManager* instance();
	static void create();
	static void destroy();
	bool isReady(); //[hIH

	enum Bgm{
		BGM_TITLE, //^Cg
		BGM_GAME, //Q[

		BGM_MAX,
	};
	enum Se{
		SE_EXPLOSION, //
		SE_DEATH, //S
		SE_CURSOR_MOVE, //J[\ړ
		SE_SELECTION, //ڌ
		SE_SET_BOMB, //eݒu

		SE_MAX,
	};
	//BGM炷BBGM͓ɈȂB܂AɃ[vB
	void playBgm( Bgm );
	void stopBgm();
	//SE炷BSE͖点ƂꂽB
	void playSe( Se );
private:
	SoundManager();
	~SoundManager();

	//Wave͑Oă[hĂ܂B
	GameLib::Sound::Wave mBgmWaves[ BGM_MAX ];
	GameLib::Sound::Wave mSeWaves[ SE_MAX ];
	//Player͍Đ
	GameLib::Sound::Player mBgmPlayer; //Ă
	static const int SE_PLAYER_MAX = 4; //ɖ炷SE4܂ŁBÂɏĂB
	GameLib::Sound::Player mSePlayers[ SE_PLAYER_MAX ]; //͔zŖt[`FbNďIĂ폜B
	int mSePlayerPos; //SEꏊB

	static SoundManager* mInstance;
};

#endif
