#ifndef INCLUDED_VECTOR2_H
#define INCLUDED_VECTOR2_H

class Vector2{
public:
	//ȂRXgN^
	Vector2();
	//RXgN^
	Vector2( int x, int y );
	//doubleRXgN^
	Vector2( double x, double y );
	//Vector2RXgN^
	Vector2( const Vector2& );
	//Z
	void operator+=( const Vector2& );
	//Z
	void operator-=( const Vector2& );
	//Rs[
	void operator=( const Vector2& );
	//ZZbg
	void setAdd( const Vector2&, const Vector2& );
	//ZZbg
	void setSub( const Vector2&, const Vector2& );
	//|ZZbg
	void setMul( const Vector2&, const Vector2& );
	//ԂZbg( this = a + u*ab + v*ac )
	void setInterporation( 
		const Vector2& a, 
		const Vector2& ab, 
		const Vector2& ac, 
		double u, 
		double v );

	double x;
	double y;
};

#endif
