#ifndef INCLUDED_MATRIX23_H
#define INCLUDED_MATRIX23_H

class Vector2;

class Matrix23{
public:
	Matrix23(); //ftHgŃRXgNg
	//ړs񐶐
	void setTranslation( const Vector2& );
	//]s񐶐
	void setRotation( double radian );
	//gks񐶐
	void setScaling( const Vector2& );
	//xN^Ɗ|Z
	void multiply( Vector2* out, const Vector2& in ) const;
	//sƊ|Z
	void operator*=( const Matrix23& );
	//ړsĉE炩
	void translate( const Vector2& );
	//]sĉE炩
	void rotate( double radian );
	//gksĉE炩
	void scale( const Vector2& );
private:
	double m00, m01, m02;
	double m10, m11, m12;
};

#endif
