#include "GameLib/Framework.h"
#include "Vector3.h"
#include "Matrix34.h"
#include "GameLib/Math.h"
using namespace GameLib;
#include <sstream>
using namespace std;

Vector3 gEyePosition( 0.0, 0.0, 1.0 );
Vector3 gEyeTarget( 0.0, 0.0, 0.0 );
int gCount;

namespace GameLib{
	void Framework::update(){
		setFrameRate( 60 );
		//̒_z
		Vector3 p[ 4 ];
		unsigned c[ 4 ]; //킩₷悤ɐF
		p[ 0 ].set( -1000.0, 0.0, -1000.0 );
		p[ 1 ].set( -1000.0, 0.0, 1000.0 );
		p[ 2 ].set( 1000.0, 0.0, -1000.0 );
		p[ 3 ].set( 1000.0, 0.0, 1000.0 );
		c[ 0 ] = 0xffff0000; //
		c[ 1 ] = 0xff00ff00; //
		c[ 2 ] = 0xff0000ff; //
		c[ 3 ] = 0xffffffff; //

		//r[s낤
		Matrix34 m;
		m.setViewTransform( gEyePosition, gEyeTarget ); //̒{̂Ȃ̂łQƂ̂

		//sɃxN^ĉ
		for ( int i = 0; i < 4; ++i ){
			m.multiply( &p[ i ], p[ i ] );
		}

		//jANbvƃt@[Nbv
		const double nearClip = 1.0;
		const double farClip = 10000.0;
		//jAƃt@[Z͈͕ϊ̎
		const double zConvA = 1.0 / ( nearClip - farClip ); //1/(n-f)
		const double zConvB = nearClip * zConvA; //n/(n-f)

		//n[hEFAɓnB4
		double p4[ 4 ][ 4 ];
		for ( int i = 0; i < 4; ++i ){
			p4[ i ][ 0 ] = p[ i ].x;
			//y640/480ďc𒲐
			p4[ i ][ 1 ] = p[ i ].y * 640.0 / 480.0;
			//wɔ͈͕ϊOzu}CiXɂāvi[BZOƂ̃}CiXKvB
			p4[ i ][ 3 ] = -p[ i ].z;
			//z͈͕ϊ
			p4[ i ][ 2 ] = zConvA * p[ i ].z + zConvB; //͈͕ϊŽ
			//zwĂB
			p4[ i ][ 2 ] *= p4[ i ][ 3 ];
		}
		//lp``B
		drawTriangle3DH( p4[ 0 ], p4[ 1 ], p4[ 2 ], 0, 0, 0, c[ 0 ], c[ 1 ], c[ 2 ] );
		drawTriangle3DH( p4[ 3 ], p4[ 1 ], p4[ 2 ], 0, 0, 0, c[ 3 ], c[ 1 ], c[ 2 ] );

		++gCount;

		//_ƒ_Kɂ
		gEyePosition.x = sin( gCount ) * 2000;
		gEyePosition.z = cos( gCount ) * 2000;
		gEyePosition.y = 1000.f;
		gEyeTarget.x = gCount % 100;
		gEyeTarget.y = gCount % 200;
		gEyeTarget.z = gCount % 300;
	}
}
