#include "GameLib/Framework.h"
#include "Vector3.h"
#include "Matrix34.h"

#include <sstream>
using namespace std;

Vector3 gTranslation( 0.0, 0.0, 0.0 );
Vector3 gScale( 1.0, 1.0, 1.0 );
int gCount;

namespace GameLib{
	void Framework::update(){
		setFrameRate( 60 );

		//̒_z
		Vector3 p[ 4 ];
		p[ 0 ].set( -500.0, -300.0, -1000.0 );
		p[ 1 ].set( -500.0, -300.0, 1000.0 );
		p[ 2 ].set( 500.0, -300.0, -1000.0 );
		p[ 3 ].set( 500.0, -300.0, 1000.0 );
		//s낤
		//g債ĂړBtAړāAgB
		Matrix34 m;
		m.setTranslation( gTranslation );
		m.scale( gScale );
		//sɃxN^ĉ
		for ( int i = 0; i < 4; ++i ){
			m.multiply( &p[ i ], p[ i ] );
		}

		//jANbvƃt@[Nbv
		const double nearClip = 1.0;
		const double farClip = 10000.0;
		//jAƃt@[Z͈͕ϊ̎
		const double zConvA = 1.0 / ( nearClip - farClip ); //1/(n-f)
		const double zConvB = nearClip * zConvA; //n/(n-f)

		//n[hEFAɓnB4
		double p4[ 4 ][ 4 ];
		for ( int i = 0; i < 4; ++i ){
			p4[ i ][ 0 ] = p[ i ].x;
			//y640/480ďc𒲐
			p4[ i ][ 1 ] = p[ i ].y * 640.0 / 480.0;
			//wɔ͈͕ϊOzu}CiXɂāvi[BZOƂ̃}CiXKvB
			p4[ i ][ 3 ] = -p[ i ].z;
			//z͈͕ϊ
			p4[ i ][ 2 ] = zConvA * p[ i ].z + zConvB; //͈͕ϊŽ
			//zwĂB
			p4[ i ][ 2 ] *= p4[ i ][ 3 ];
		}
		//lp``B
		drawTriangle3DH( p4[ 0 ], p4[ 1 ], p4[ 2 ] );
		drawTriangle3DH( p4[ 3 ], p4[ 1 ], p4[ 2 ] );

		//ړʁAg嗦Kɂ
		gTranslation.x = gCount % 1000 - 500;
		gTranslation.y = gCount % 800 - 400;
		gTranslation.z = gCount % 600 - 300 - 2000;
		gScale.x = ( gCount % 500 ) / 500.0 + 0.5;
		gScale.y = ( gCount % 300 ) / 300.0 + 0.5;
		gScale.z = ( gCount % 100 ) / 100.0 + 0.5;

		++gCount;
	}
}
