#ifndef INCLUDED_BULLET_H
#define INCLUDED_BULLET_H

class Model;
class GraphicsDatabase;
class Matrix44;
class Vector3;

class Bullet{
public:
	Bullet();
	~Bullet();
	void create( 
		GraphicsDatabase*,
		const char* batchName,
		const Vector3& position,
		double angleX, double angleY );
	const Vector3* position() const;
	void update( const Vector3& enemyPos );
	void draw( const Matrix44& projectionVewMatrix ) const;
	bool isEmpty() const; //gĂȂtrueBmCount<0Ŕ
private:
	Model* mModel;
	int mCount; //-1Ȃ炻̒e͋󂾂ƂƂɂ悤B

	static const float mHomingX; //pxU\X
	static const float mHomingY; //pxU\Y
	static const int mLife; //e
	static const float mSpeed; //ȇx
};

#endif