#ifndef INCLUDED_GAMELIB_HASHSET_H
#define INCLUDED_GAMELIB_HASHSET_H

#include "GameLib/Base/Stack.h"
#include "GameLib/Base/Hash.h"
#include "GameLib/Base/Array.h"

namespace GameLib{

///EeʎwnbVe[u
/*!
nbV֐͑Srbg̘ae[uTCYŏ]PȕłB
Srbgł邽߁ANX̃TCY傫ƃRXg傫Ȃ\B
ȂAvf͑}ȂBstd::mutli_setKvɂȂƂȂ炾B
*/
template< class T, class H = Hash< T > > class HashSet{
public:
	///ftHgBsetCapacityĂ΂ȂƓȂ
	HashSet();
	///őeʂwBe[uTCY̓ftHgcapacityȏ̍ŏ̑fB
	explicit HashSet( int capacity, int tableSize = 0 );
	~HashSet();
	///ĊmہBgԂŌĂԂassertBclear()B
	void setCapacity( int capacity, int tableSize = 0 );
	///őeʎ擾
	int capacity() const;
	///݂̗vf擾
	int size() const;
	///S
	void clear();
	///ǉBǉꏊԂB̂łɂΖĖCe[^ԂB
	int add( const T& );
	///BԂ̂̓Ce[^
	int find( const T& );
	///BA邩ǂԂ
	bool isIn( const T& ) const;
	///Ce[^w肵č폜B폜trueԂB
	bool remove( int position );
	///l擾B͋Ȃ̂constł񋟂ȂB
	const T* value( int position ) const;
	//ȉPȃXgƂăANZXۂ̃C^[tFCXBЕ
	int next( int position ) const;
	int first() const;
	///position[B
	bool isEnd( int position ) const;
	///PȂzɕϊBOsize()TCYneẅnƁB
	void copyTo( T* ) const;
	///ArrayɃRs[B̂̂nB
	void copyTo( Array< T >* ) const;
private:
	void operator=( const HashSet& ); //֎~
	HashSet( const HashSet& ); //Rs[RXgN^֎~

	int* mNexts;
	T* mValues;
	Stack< int > mEmptyStack;
	int mCapacity;
	int mSize;
	int mTableSize;
};

} //namespace GameLib
#include "GameLib/Base/Impl/HashSetImpl.h" //g͂̒

#endif

