#ifndef INCLUDED_GAMELIB_THREADING_SEMAPHORE_H
#define INCLUDED_GAMELIB_THREADING_SEMAPHORE_H

namespace GameLib{
namespace Threading{

///܂lɃbNłMutexB
class Semaphore{
public:
	///̏lŐBmaxCount0startCountɂȂB
	static Semaphore create( int startCount, int maxCount = 0 );
	///JEg1炻ƂBł0Ɩ炳B
	void decrease();
	///JEg𑝂₷Bȗ1ÂB
	void increase( int value = 1 );

	Semaphore();
	~Semaphore();
	Semaphore( const Semaphore& );
	operator void*() const;
	Semaphore& operator=( const Semaphore& );
	void release();
	bool operator==( const Semaphore& ) const;
	bool operator!=( const Semaphore& ) const;
private:
	class Impl;
	Impl* mImpl;
};

} //namespace Threading
} //namespace GameLib

#endif
