#include "GameLib/Framework.h"
#include "GameLib/Input/Manager.h"
#include "GameLib/Input/Keyboard.h"
#include "GameLib/Math/Vector3.h"
#include "GameLib/Math/Matrix34.h"
#include "GameLib/Math/Matrix44.h"
#include "GameLib/Math/Functions.h"
#include "GameLib/Scene/StringRenderer.h"
#include "GameLib/Scene/Font.h"
#include <sstream>
using namespace std;
using namespace GameLib::Math;
using namespace GameLib::Graphics;
using namespace GameLib::Scene;

int gCount;
Font gFont0;
Font gFont1;
StringRenderer gStringRenderer;

namespace GameLib{
	void Framework::configure( Configuration* c ){
		c->enableVSync( true );
	}
	void Framework::update(){
		if ( gCount == 0 ){
			//WindowstHg(A`GCAXt)
			gFont0 = Font::create( "lr SVbN", 32, false, false, false, true ); //MS͑SpÃXy[X͔pBC悤B
			//WindowstHg(A`GCAXt)
			gFont1 = Font::create( "lr ", 32, false, false, false, true ); //MS͑SpÃXy[X͔pBC悤B
			//`NX(AadďĂяo)
			gStringRenderer = StringRenderer::create( 2048, 128 );
		}
		//`悵Ă݂B
		ostringstream oss;
		oss << "t[[g: " << frameRate();
		//true͎܂Ԃ@\Bfalseɂΐ܂ԂȂ
		gStringRenderer.setFont( gFont0 );
		gStringRenderer.add( gCount % 640, 0, oss.str().c_str(), 0xffffffff, true );
		oss.str( "" );
		oss << "@ؗi߁jíjΓi₫ǂjAɂ͂킴ƐԊ~pЂiłӁj̒Δɑ΂ЂĘbGijȂBlA͗҂ɍ苏O\ȌAĵ₤ɗhȔij|Ђ鍭̐ƁAoނׂJ̎R̐FƁU߂Đi݂ǂĵЈgُA@؂ƒʂKLRƏAД^_ƍiނjہi܂j߂Ĉ􎆂ЂɈ{ρiۂ񂴂jłƗ߂hFC̗l͂ǁA";
		//true͎܂Ԃ@\Bfalseɂΐ܂ԂȂ
		gStringRenderer.setFont( gFont1 );
		gStringRenderer.add( gCount % 640, 100, oss.str().c_str(), 0xffffffff, true );

		gStringRenderer.draw();
		++gCount;

		if ( isEndRequested() ){
			gStringRenderer.release(); //O[oȂ̂ŊJKv
			gFont0.release();
			gFont1.release();
		}
	}
}
